<template>
	<v-sheet class="d-flex justify-space-around align-center pt-8">
		<div>
			<v-img :width="577" src="@/assets/img/car-form.png"></v-img>
		</div>
		<v-sheet width="384" color="#fff" class="my-16">
			<v-card-title class="text-lg-h4 px-0">Demo Dashboard</v-card-title>
			<v-card-text class="px-0"> Hi there! Nice to see you again. </v-card-text>

			<form @submit.prevent="onSubmit" novalidate>
				<div
					class="mt-4 mb-2"
					:class="{ error: v$.logIn.email.$errors.length }"
				>
					<label>Email address</label>
					<span> *</span>

					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						class="mt-2"
						rounded="lg"
						persistent-hint
						hide-details="auto"
						variant="outlined"
						@blur="v$.logIn.email.$touch"
						v-model="logIn.email"
					/>

					<div
						class="mt-0 pt-0"
						v-for="error of v$.logIn.email.$errors"
						:key="error.$uid"
					>
						<small class="error-msg text-red pt-0 mt-0">{{
							error.$message
						}}</small>
					</div>
				</div>

				<div
					class="mt-6 mb-3"
					:class="{ error: v$.logIn.password.$errors.length }"
				>
					<label>Password</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						:type="showPassword ? 'text' : 'password'"
						:append-inner-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
						@click:append-inner="showPassword = !showPassword"
						hide-details
						autocomplete="on"
						@blur="v$.logIn.password.$touch"
						v-model="logIn.password"
					></v-text-field>
					<div v-for="error of v$.logIn.password.$errors" :key="error.$uid">
						<small class="error-msg text-red">{{ error.$message }}</small>
					</div>
				</div>

				<v-btn @click="togglePage" class="text-red text-capitalize px-0" flat>
					Forgot Password?
				</v-btn>

				<v-btn class="mt-4" color="#D90E32" height="48" block type="submit">
					sign in
					<v-icon dark right>custom-icon</v-icon>
				</v-btn>

				<v-btn
					class="mt-4"
					height="48"
					block
					type="submit"
					color="red"
					variant="outlined"
				>
					contact support
				</v-btn>
			</form>
		</v-sheet>
	</v-sheet>
</template>

<script>
import { useVuelidate } from '@vuelidate/core'
import { required, email, minLength } from '@vuelidate/validators'

export default {
	name: 'SignIn',
	setup() {
		return { v$: useVuelidate() }
	},
	props: {
		isActive: {
			type: Boolean,
			default: false,
		},
		adminInfo: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			logIn: {
				email: this.adminInfo.email,
				password: this.adminInfo.password,
			},
			showPassword: false,
		}
	},
	validations() {
		return {
			logIn: {
				email: { email, required },
				password: { required, minLength: minLength(8) },
			},
		}
	},

	methods: {
		onSubmit() {
			if (this.v$.$invalid) {
				this.v$.$touch()
				return
			}

			if (this.logIn.email !== this.adminInfo.email) {
				return
			}
			if (this.logIn.password !== this.adminInfo.password) {
				return
			}

			this.$emit('enter')
		},
		togglePage() {
			this.$emit('toggleSignIn', this.isActive)
		},
	},
}
</script>
